package bookejbdemo.business;

import org.objectweb.fdb.impl.meta.*;
import org.objectweb.fdb.impl.meta.type.*;

import java.util.Random;
import java.io.Serializable;

public class Book implements Serializable {
    private Book() {
    }

    private Book(String title, int pages) {
        this.pages = pages;
        this.title = title;
    }

    public String getComments() {
        return comments;
    }

    public void setComments(String comments) {
        this.comments = comments;
    }

    public int getPages() {
        return pages;
    }

    public void setPages(int pages) {
        this.pages = pages;
    }

    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public static Book newBook() {
        return new Book(getNewTitle(), getNewPages());
    }

    public Object[] toArray() {
        Object[] result = new Object[3];
        result[0] = title;
        result[1] = new Integer(pages);
        result[2] = comments;
        return result;
    }

    public String toString() {
        StringBuffer result = new StringBuffer();
        result.append("'").append(title).append(", ").append(pages).append(" pages");
        if (comments != null) {
            result.append(", ").append(comments);
        }
        result.append("'");
        return result.toString();
    }

    public static Book toBook(Object[] array) {
        Book book = new Book();
        book.setTitle((String) array[0]);
        book.setPages(((Integer) array[1]).intValue());
        book.setComments((String) array[2]);
        return book;
    }

    public static ClassMetaDescription getMetaDescription() {
        ClassMetaDescription meta = new ClassMetaDescription(Book.class.getName());
        meta.addField(new FieldDescription("title", new StringType()));
        meta.addField(new FieldDescription("pages", new IntType()));
        meta.addField(new FieldDescription("comments", new StringType()));
        return meta;
    }

    private static String getNewTitle() {
        return titles[random.nextInt(titles.length)];
    }

    public static int getNewPages() {
        return random.nextInt(1000);
    }

    private String title;
    private int pages;
    private String comments;

    private static Random random = new Random();
    private static String[] fieldNames = {"title", "pages", "comments"};
    private static String titles[] = {"Death Off Stage",
                                      "At the Edge",
                                      "Fingersmith",
                                      "Metes and Bounds",
                                      "A Fountain Filled with Blood",
                                      "A Cold Case of Murder",
                                      "Innocent Hearts",
                                      "Tipping the Velvet",
                                      "Bittersweet",
                                      "The Jester",
                                      "2nd Chance",
                                      "Beyond All Reason"};
}
