package org.objectweb.fdb;

import org.objectweb.fdb.impl.InternalFdbFactory;

/**
 * FdbFactory is used to create new connection to Fdb, represented by a FdbSession object.
 * FdbFactory need properties file path of the base to create FdbSession instances.
 */
public class FdbFactory {

    /**
     * Create a new instance of FdbSession interface, working on the base corresponding to the properties file specified.
     * @param propertiesFilePath properties file path. This path can be absolute, relative to working directory, or can be the name of a file in the working classpath.
     * @return FdbSession the new FdbSession instance just created
     * @throws org.objectweb.fdb.exception.FdbDatabaseException Thrown if a problem occured during initialisation of the session.
     */
    public static synchronized FdbSession getNewSession(String propertiesFilePath) {
        return InternalFdbFactory.getNewSession(propertiesFilePath);
    }
}
