package org.objectweb.fdb.api;

import org.objectweb.fdb.FdbLoid;

import java.util.Collection;

public interface FdbLockManager {
    public static final String OPTIMISTIC_MODE = "optimistic";
    public static final String PESSIMISTIC_MODE = "pessimistic";

    void setLockTable(FdbLockTable lockTable);

    FdbDataObject getLockedValue(FdbLoid floid, Object sessionId);

    void setSession(FdbSessionTx session);

    void begin();

    void checkLocksForSession(Collection floids, Object sessionId);

    void commit();

    boolean containsDeletedValue(FdbLoid floid, Object sessionId);

    boolean containsLockedValue(FdbLoid floid, Object sessionId);

    void finishCreateObject(FdbLoid floid, FdbDataObject objectToCreate);

    void finishDeleteObjectByOid(FdbLoid floid);

    void finishMakeNewFileOid(FdbLoid floid);

    void finishReadObjectByOid(FdbLoid floid, FdbDataObject objectToRead, short update);

    void finishUpdateObjectByOid(FdbLoid floid, FdbDataObject objectToUpdate, short update);

    void prepareCreateObject(FdbLoid floid, FdbDataObject objectToCreate);

    void prepareDeleteObjectByOid(FdbLoid floid, short update);

    void prepareReadObjectByOid(FdbLoid floid);

    void prepareUpdateObjectByOid(FdbLoid floid, FdbDataObject objectToUpdate);

    void rollback();
}
