package org.objectweb.fdb.api;

import org.objectweb.fdb.FdbLoid;
import org.objectweb.fdb.impl.lock.Lock;

import java.util.Collection;
import java.util.Iterator;
import java.util.Map;

public interface FdbLockTable {
    Iterator getKeys();

    Lock getLock(FdbLoid floid);

    FdbDataObject getLockedValue(FdbLoid floid, Object sessionId);

    Map getLocks();

    void checkLocksForSession(Collection floids, Object sessionId);

    boolean containsDeletedValue(FdbLoid floid, Object sessionId);

    boolean containsLockedValue(FdbLoid floid, Object sessionId);

    boolean hasLock(FdbLoid floid);

    void publishLocks();

    void removeLockByFloid(FdbLoid floid);
}
