package org.objectweb.fdb.api;

import org.objectweb.fdb.impl.FdbPoid;
import org.objectweb.fdb.impl.IfaIndexImpl;
import org.objectweb.fdb.impl.IdentityProviderImpl;
import org.objectweb.fdb.impl.InFileAddress;
import org.objectweb.fdb.impl.meta.FdbMetaRepository;

public interface FdbLogicalSystemPageAccess {

    void insertDatas(FdbPoid fpoid, FdbDataObject datas);

    FdbDataObject readDatas(FdbPoid fpoid);

    FdbPoid updateDatas(FdbPoid fpoid, FdbDataObject datas);

    void deleteDatas(FdbPoid fpoid);


    FdbPoid allocateNewFpoid(Object clid);

    void desallocateFpoid(FdbPoid fpoid);


    InFileAddress allocateLeafAddressAndInsert(FdbObject oids);

    Object readLeaf(InFileAddress ifa);

    void updateLeaf(InFileAddress ifa, FdbObject oids);

    void removeLeaf(InFileAddress ifa);

    InFileAddress allocateNodeAddressAndInsert(FdbObject node);

    Object readNode(InFileAddress ifa);

    void updateNode(InFileAddress ifa, FdbObject node);

    void removeNode(InFileAddress ifa);


    void start();

    void commit();

    void rollback();


    public void cleanAllNullValue();

    FdbPhysicalFileAccess getPhysicalAccess();
}
