package org.objectweb.fdb.api;

import org.objectweb.fdb.FdbLoid;
import org.objectweb.fdb.impl.FdbProperties;

public interface FdbSessionTx extends FdbSessionInternal {
    FdbOidTable getOidTable();

    FdbProperties getProp();

    void createObjectCommit(FdbLoid floid);

    void createObjectRollback(FdbLoid floid);

    void deleteObjectCommit(FdbLoid floid);

    void deleteObjectRollback(FdbLoid floid);

    void goToBed();

    void inspectLocks();

    void makeNewFileOidCommit(FdbLoid floid);

    void makeNewFileOidRollback(FdbLoid floid);

    FdbDataObject readObjectByOidInDataObject(Object oid, boolean withCache);

    void sleep(FdbLoid floid);

    void sleep(FdbLoid floid, String message);

    void updateObjectCommit(FdbLoid floid);

    void updateObjectRollback(FdbLoid floid);

    void wakeUp();
}
