package org.objectweb.fdb.impl;

import org.objectweb.fdb.api.FdbDataObject;
import org.objectweb.fdb.exception.FdbPoolException;

public class DataObjectImpl implements FdbDataObject {
    protected Object[] datas;

    private DataObjectImpl() {
    }

    public void init(Object[] theDatas) {
        datas = new Object[theDatas.length];
        System.arraycopy(theDatas, 0, datas, 0, theDatas.length);
    }

    public FdbDataObject getClone() {
        return newInstance(datas);
    }

    public void setDatas(Object[] newDatas) {
        if (newDatas.length != datas.length) {
            datas = new Object[newDatas.length];
        }
        System.arraycopy(newDatas, 0, datas, 0, newDatas.length);
    }

    public Object[] getDatas() {
        Object[] result = new Object[datas.length];
        System.arraycopy(datas, 0, result, 0, datas.length);
        return result;
    }

    public String toString() {
        StringBuffer sb = new StringBuffer();
        sb.append("[");
        for (int i = 0; i < datas.length; i++) {
            if (datas[i] == null) {
                sb.append("null");
            } else {
                sb.append(datas[i]);
            }
            if (i != (datas.length - 1)) {
                sb.append(";");
            }
        }
        sb.append(']');
        return sb.toString();
    }
    public static DataObjectImpl newInstance(Object[] theDatas) {
        try {
            DataObjectImpl newObject = new DataObjectImpl();
            newObject.init(theDatas);
            return newObject;
        } catch (Exception e) {
            throw new FdbPoolException("Exception in pooling",e);
        }
    }
}
