package org.objectweb.fdb.impl;

import java.io.Serializable;

public class InFileAddress implements Serializable {
    // the physical address of the FdbObject wrapper
    private String address;
    // the index of underlying physical file
    private int fileIndex;
    // the index of the data in the page
    private int index;

    public InFileAddress(String address) {
        this.address = address;
        index = 0;
        fileIndex = 0;
    }

    public String getAddress() {
        return address;
    }

    public InFileAddress getClone() {
        InFileAddress result = new InFileAddress(this.address);
        result.setIndex(this.index);
        result.setFileIndex(this.fileIndex);
        return result;
    }

    public void setFileIndex(int fileIndex) {
        this.fileIndex = fileIndex;
    }

    public int getFileIndex() {
        return fileIndex;
    }

    public InFileAddress setIndex(int index) {
        this.index = index;
        return this;
    }

    public int getIndex() {
        return index;
    }

    public boolean equals(Object obj) {
        try {
            InFileAddress candidate = (InFileAddress) obj;
            return ((candidate.address.equals(this.address)) && (candidate.index == this.index));
        } catch (Exception e) {
        }
        return false;
    }

    public int hashCode() {
        return ((index * 100000) + address.hashCode());
    }

    public String toString() {
        return "ifa(" + String.valueOf(address) + "," + String.valueOf(fileIndex) + "," + String.valueOf(index) + ")";
    }
}
