package org.objectweb.fdb.impl;

import org.objectweb.fdb.FdbLoid;
import org.objectweb.fdb.impl.FdbPoid;

import java.io.Serializable;

public class OidInfo implements Serializable {
    private FdbLoid floid;
    private FdbPoid fpoid;
    private short update;

    public OidInfo(FdbLoid floid, FdbPoid fpoid) {
        this.floid = floid;
        this.fpoid = fpoid;
        this.update = -1;
    }

    public OidInfo(FdbLoid floid, FdbPoid fpoid, short update) {
        this.floid = floid;
        this.fpoid = fpoid;
        this.update = update;
    }

    public boolean isDeleting() {
        return (fpoid == null);
    }

    public FdbLoid getFloid() {
        return floid;
    }

    public void setFpoid(FdbPoid fpoid) {
        this.fpoid = fpoid;
    }

    public FdbPoid getFpoid() {
        return fpoid;
    }

    public void setUpdate(short update) {
        this.update = update;
    }

    public short getUpdate() {
        return update;
    }

    public String toString() {
        StringBuffer sb = new StringBuffer();
        sb.append("oidi(").append(floid).append(',').append(fpoid).append(',').append(update).append(")");
        return sb.toString();
    }
}
