package org.objectweb.fdb.impl.basic;

import java.io.*;

public class RecordReader {
    ByteArrayInputStream in;
    ObjectInputStream objIn;
    String key;
    byte[] data;

    public RecordReader(String key, byte[] data) {
        this.key = key;
        this.data = data;
        in = new ByteArrayInputStream(data);
    }

    public byte[] getData() {
        return data;
    }

    public InputStream getInputStream() throws IOException {
        return in;
    }

    public String getKey() {
        return key;
    }

    public ObjectInputStream getObjectInputStream() throws IOException {
        if (objIn == null) {
            objIn = new ObjectInputStream(in);
        }

        return objIn;
    }

    /**
     * Reads the next object in the record using an ObjectInputStream.
     */
    public Object readObject()
            throws IOException, OptionalDataException,
            ClassNotFoundException {
        return getObjectInputStream().readObject();
    }
}
