package org.objectweb.fdb.impl.basic;

import org.objectweb.fdb.impl.FdbProperties;

import java.io.PrintWriter;
import java.util.Enumeration;

public class RecordsFileInspector {
    public void inspectRecordsFile(PrintWriter out, RecordsFile rf)
            throws Exception {
        out.println("RecordsFile with " + rf.getNumRecords());
        out.println("keys :");

        Enumeration enum = rf.enumerateKeys();

        while (enum.hasMoreElements()) {
            String key = enum.nextElement().toString();
            out.println(key + " : " + rf.readRecord(key).readObject().toString());
        }
    }

    public static void main(String[] args) {
        try {
            FdbProperties prop = null;

            if (args.length < 1) {
                prop = new FdbProperties("");
            } else {
                prop = new FdbProperties(args[0]);
            }

            RecordsFile rf = new RecordsFile(prop.getDbFileFullName(), "rw",
                                             prop.getKeyLength(),
                                             prop.getAdditionalSpace());
            PrintWriter out = new PrintWriter(System.out);
            (new RecordsFileInspector()).inspectRecordsFile(out, rf);
            out.flush();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
