package org.objectweb.fdb.impl.cache;

import org.objectweb.fdb.exception.FdbPoolException;

public class CacheCell {
    private CacheCell last;
    private CacheCell next;
    private Object id;
    private Object object;

    private CacheCell() {
    }

    public void init(Object id, Object object) {
        this.object = object;
        this.id = id;
        next = this;
        last = this;
    }

    public void setId(Object id) {
        this.id = id;
    }

    public Object getId() {
        return id;
    }

    public CacheCell getLast() {
        return last;
    }

    public void setObject(Object newObject) {
        object = newObject;
    }

    public Object getObject() {
        return object;
    }

    public void addLast(CacheCell cell) {
        last = cell;
    }

    public void addNext(CacheCell cell) {
        next = cell;
    }

    public void delink() {
        next.addLast(last);
        last.addNext(next);
    }

    public int hashCode() {
        return id.hashCode();
    }

    public void noMoreNext() {
        next = this;
    }

    public static CacheCell newInstance(Object id, Object object) {
        try {
            CacheCell newObject = new CacheCell();
            newObject.init(id, object);
            return newObject;
        } catch (Exception e) {
            throw new FdbPoolException("Exception in pooling",e);
        }
    }
}