package org.objectweb.fdb.impl.impltx;

import org.objectweb.fdb.FdbLoid;
import org.objectweb.fdb.api.FdbPhysicalFileAccess;
import org.objectweb.fdb.api.FdbOidTable;
import org.objectweb.fdb.impl.OidTableImpl;
import org.objectweb.fdb.impl.FdbProperties;
import org.objectweb.fdb.impl.OidInfo;

import java.util.List;

public class OidTableTxImpl extends OidTableImpl {

    private OidTableTxImpl(FdbPhysicalFileAccess physicalAccess, FdbProperties properties) {
        super(physicalAccess, properties);
    }

    public synchronized void setUpdate(FdbLoid floid, short value) {
        if (!floidTable.containsKey(floid)) {
            loadOidPage(floid);
        }
        OidInfo info = (OidInfo) floidTable.get(floid);
        info.setUpdate(value);
        updateOidInfoInBase(info, false);
    }

    public synchronized short getUpdate(FdbLoid floid) {
        if (!floidTable.containsKey(floid)) {
            if (!loadOidPage(floid)) {
                return -1;
            }
        }
        return ((OidInfo) floidTable.get(floid)).getUpdate();
    }


    /**********************************    STATIC    ********************************************/

    public static FdbOidTable getAnOidTable(FdbPhysicalFileAccess physicalAccess, FdbProperties properties) {
        OidTableTxImpl oidTable;
        try {
            List list = (List) physicalAccess.readFileObjectAt(OID_IFA_LIST).getData();
            oidTable = new OidTableTxImpl(physicalAccess, properties);
            oidTable.oidIfaList = list;
            oidTable.readAtTable();
        } catch (Exception e) {
            oidTable = new OidTableTxImpl(physicalAccess, properties);
            oidTable.createAtList();
        }
        oidTable.oidPageSize = properties.getOidPageSize();
        return oidTable;
    }

}
