package org.objectweb.fdb.impl.lock;

import org.objectweb.fdb.api.FdbDataObject;

public class InTransactionImage {

    public InTransactionImage(int currentAction, FdbDataObject currentValue, short update) {
        this.currentAction = currentAction;
        this.currentValue = currentValue;
        this.update = update;
    }


    public int getCurrentAction() {
        return currentAction;
    }

    public boolean isReadAction() {
        return (currentAction == READ_ACTION);
    }

    public boolean isCreateAction() {
        return (currentAction == CREATE_ACTION);
    }


    public FdbDataObject getCurrentValue() {
        return currentValue;
    }

    public void setValue(int action, FdbDataObject currentValue) {
        if ((action != READ_ACTION) || (currentAction == READ_ACTION)) {
            this.currentValue = currentValue;
            currentAction = action;
        }
    }


    public void update() {
        update++;
    }

    public short getUpdate() {
        return update;
    }

    public void setUpdate(short update) {
        if (update != (short) -1) {
            this.update = update;
        }
    }


    public String toString() {
        StringBuffer sb = new StringBuffer();
        sb.append("ITImage : ").append(getActionAsString(currentAction)).append(", ");
        sb.append(currentValue).append(", update=").append(update);
        return sb.toString();
    }

    private String getActionAsString(int action) {
        if (action == NO_ACTION) {
            return "no_action";
        } else if (action == NEW_OID_ACTION) {
            return "new_action";
        } else if (action == CREATE_ACTION) {
            return "create_action";
        } else if (action == UPDATE_ACTION) {
            return "update_action";
        } else if (action == DELETE_ACTION) {
            return "delete_action";
        } else {
            return "read_action";
        }
    }


    private FdbDataObject currentValue;
    private int currentAction;
    private short update;


    public static final int NO_ACTION = 0;
    public static final int NEW_OID_ACTION = 1;
    public static final int CREATE_ACTION = 2;
    public static final int UPDATE_ACTION = 3;
    public static final int DELETE_ACTION = 4;
    public static final int READ_ACTION = 5;
}
