package org.objectweb.fdb.impl.lock;

import org.objectweb.fdb.FdbLoid;
import org.objectweb.fdb.api.FdbDataObject;
import org.objectweb.fdb.api.FdbLockManager;
import org.objectweb.fdb.api.FdbLockTable;
import org.objectweb.fdb.api.FdbSessionTx;

import java.util.Collection;

public abstract class LockManagerDefault implements FdbLockManager {
    protected FdbSessionTx session;
    protected FdbLockTable lockTable;
    protected Object sessionId;

    public void setLockTable(FdbLockTable lockTable) {
        this.lockTable = lockTable;
    }

    public FdbDataObject getLockedValue(FdbLoid floid, Object sessionId) {
        return lockTable.getLockedValue(floid, sessionId);
    }

    public void setSession(FdbSessionTx session) {
        this.session = session;
        this.sessionId = session.getSessionId();
    }

    public void begin() {
    }

    public void checkLocksForSession(Collection floids, Object sessionId) {
        lockTable.checkLocksForSession(floids, sessionId);
    }

    public boolean containsDeletedValue(FdbLoid floid, Object sessionId) {
        return lockTable.containsDeletedValue(floid, sessionId);
    }

    public boolean containsLockedValue(FdbLoid floid, Object sessionId) {
        return lockTable.containsLockedValue(floid, sessionId);
    }

    public void finishCreateObject(FdbLoid floid, FdbDataObject objectToCreate) {
    }

    public void finishDeleteObjectByOid(FdbLoid floid) {
    }

    public void finishMakeNewFileOid(FdbLoid floid) {
    }

    public void finishReadObjectByOid(FdbLoid floid, FdbDataObject objectToRead,
                                      short update) {
    }

    public void finishUpdateObjectByOid(FdbLoid floid,
                                        FdbDataObject objectToUpdate, short update) {
    }

    public void prepareCreateObject(FdbLoid floid, FdbDataObject objectToCreate) {
    }

    public void prepareDeleteObjectByOid(FdbLoid floid, short update) {
    }

    public void prepareReadObjectByOid(FdbLoid floid) {
    }

    public void prepareUpdateObjectByOid(FdbLoid floid,
                                         FdbDataObject objectToUpdate) {
    }
}
