package org.objectweb.fdb.impl.page;

import org.objectweb.fdb.impl.page.PageInfo;
import org.objectweb.fdb.impl.InFileAddress;

public class InMemoryPageInfo {
    private InFileAddress ifa;
    private int freeSpace;
    private int reservedSpace;

    public InMemoryPageInfo(PageInfo pageInfo) {
        ifa = pageInfo.getPageIfa();
        freeSpace = pageInfo.getEmptySpace();
        reservedSpace = 0;
    }

    public void setFreeSpace(int freeSpace) {
        this.freeSpace = freeSpace;
    }

    public int getFreeSpace() {
        return freeSpace - reservedSpace;
    }

    public InFileAddress getInstancePageIfa() {
        return ifa;
    }

    public void reservePlace() {
        reservedSpace++;
    }

    public void getReservedPlace() {
        reservedSpace--;
        freeSpace--;
    }

    public String toString() {
        return "IMPO:" + freeSpace + "@" + ifa.getAddress();
    }
}
