package org.objectweb.fdb.impl.page;

import org.objectweb.fdb.api.FdbObject;
import org.objectweb.fdb.impl.InFileAddress;

public class Page implements FdbObject {
    protected Object[] storedDatas;
    protected transient InFileAddress ifa;

    public Page(int size) {
        storedDatas = new Object[size];
    }

    public Object[] getAllDatas() {
        return storedDatas;
    }

    public void setData(Object data) {
    }

    public Object getData() {
        return storedDatas;
    }

    public void setDataAt(InFileAddress dataIfa, Object dataToInsert) {
        storedDatas[dataIfa.getIndex()] = dataToInsert;
    }

    public void setDataAt(int index, Object dataToInsert) {
        storedDatas[index] = dataToInsert;
    }

    public Object getDataAt(InFileAddress dataIfa) {
        return storedDatas[dataIfa.getIndex()];
    }

    public void setIfa(InFileAddress ifa) {
        this.ifa = ifa.getClone();
    }

    public InFileAddress getIfa() {
        return ifa;
    }

    public int getSize() {
        return storedDatas.length;
    }

    public String toString() {
        if (ifa != null) {
            return pageName() + "@" + String.valueOf(ifa) + ":" + dataToString();
        } else {
            return pageName() + ":" + dataToString();
        }
    }

    private String dataToString() {
        StringBuffer sb = new StringBuffer();
        sb.append("[");
        for (int i = 0; i < storedDatas.length; i++) {
            if (storedDatas[i] == null) {
                sb.append("null");
            } else {
                sb.append(storedDatas[i]);
            }
            if (i != (storedDatas.length - 1)) {
                sb.append(";");
            }
        }
        sb.append("]");
        return sb.toString();
    }

    protected String pageName() {
        return "P";
    }

    public static final short CLASSPAGE_TYPE = 0;
    public static final short INSTANCEPAGE_TYPE = 1;
    public static final short OIDPAGE_TYPE = 2;
    public static final short SYSTEMPAGE_TYPE = 3;
    public static final short NODEPAGE_TYPE = 4;
    public static final short LEAFPAGE_TYPE = 5;
}
