package org.objectweb.fdb.impl.page;

import org.objectweb.fdb.impl.InFileAddress;

import java.io.Serializable;
import java.util.Iterator;
import java.util.LinkedList;

public class PageInfo implements Serializable {
    private InFileAddress pageIfa;
    private LinkedList freePlaces;
    private Object pid;
    private short size;
    private short pageType;

    public PageInfo(short pageSize, short pageType) {
        this.freePlaces = new LinkedList();
        this.size = pageSize;
        this.pageType = pageType;

        for (int i = 0; i < size; i++) {
            freePlaces.addLast(new Integer(i));
        }
    }

    public short getPageType() {
        return pageType;
    }

    public Iterator getAllFreePlace() {
        return freePlaces.iterator();
    }

    public boolean isEmpty() {
        return (freePlaces.size() == size);
    }

    public int getEmptySpace() {
        return freePlaces.size();
    }

    public Integer getFreePlace() {
        Integer result = (Integer) freePlaces.getFirst();
        freePlaces.removeFirst();
        return result;
    }

    public void setPageIfa(InFileAddress pageIfa) {
        this.pageIfa = pageIfa;
    }

    public InFileAddress getPageIfa() {
        return pageIfa.getClone();
    }

    public void setPid(Object pid) {
        this.pid = pid;
    }

    public Object getPid() {
        return pid;
    }

    public void freeSpaceAt(Integer index) {
        freePlaces.addLast(index);
    }

    public boolean hasFreeSpaceAt(Integer index) {
        return freePlaces.contains(index);
    }

    public void noMorefreeSpaceAt(Integer index) {
        freePlaces.remove(index);
    }

    public String toString() {
        StringBuffer sb = new StringBuffer();
        sb.append("PageInfo:").append(pid).append(':').append(pageIfa)
                .append(':').append(getEmptySpace());

        return sb.toString();
    }
}
