package org.objectweb.fdb.impl.trace;

import java.util.Collection;
import java.util.HashMap;
import java.util.Iterator;

public class TraceContext {
    private HashMap moduleNames;
    private boolean isEnable;
    private Trace tracer;

    public TraceContext(boolean enable, Collection moduleNamesToAdd) {
        isEnable = enable;
        moduleNames = new HashMap();
        Iterator i = moduleNamesToAdd.iterator();
        while (i.hasNext()) {
            moduleNames.put(i.next(), null);
        }
    }

    public boolean isTracing(Trace.Module component) {
        return (isEnable && moduleNames.containsKey(component.getName()));
    }

    public Trace getTracer() {
        if (tracer == null) {
            if (moduleNames.isEmpty()) {
                tracer = new TraceNull();
            } else {
                tracer = new TraceErr(this);
                tracer.enableTrace(isEnable);
                tracer.init(moduleNames.keySet().iterator());
            }
        }
        return tracer;
    }
}
