package org.objectweb.fdb.impl.trace;

import java.io.PrintWriter;

public class TracePrintWriter extends TraceImpl {
    private PrintWriter logger;

    protected String getTraceType() {
        return "TracePrintWritter";
    }

    public TracePrintWriter(TraceContext context, Trace current, PrintWriter printWriter) {
        super(context);
        setEnabledModules(current.enabledModules());
        logger = printWriter;
    }

    public TracePrintWriter(TraceContext context, PrintWriter printWriter) {
        super(context);
        logger = printWriter;
    }

    public void printException(Object message, Throwable t) {
        print(TRACE_ON, String.valueOf(message));
        t.printStackTrace(logger);
    }

    protected void print(Module module, String message) {
        logger.print(pad(module));

        if (isShowThread()) {
            logger.print(" {" + Thread.currentThread() + "}");
        }

        logger.println(" " + message);
        logger.flush();
    }
}
