package org.objectweb.fdb.impl.util;

public class FdbUtils {

    /**
     * Gets a substring of the specified string avoiding exceptions.
     * A negative start position can be used to start n characters from
     * the end of the string.
     *
     * @param str  the string to get the substring from
     * @param start  the position to start from,  negative means
     * count back from the end of the string by this many characters
     * @return substring from start position
     */
    public static String substring(String str, int start) {
        if (str == null) {
            return null;
        }

        // handle negatives, which means last n characters
        if (start < 0) {
            start = str.length() + start; // remember start is negative
        }

        if (start < 0) {
            start = 0;
        }

        if (start > str.length()) {
            return "";
        }

        return str.substring(start);
    }
}
