package org.objectweb.fdb.jca;

import javax.resource.spi.ConnectionManager;
import javax.resource.spi.ManagedConnectionFactory;
import javax.resource.spi.ConnectionRequestInfo;
import javax.resource.spi.ManagedConnection;
import javax.resource.ResourceException;
import javax.transaction.xa.XAException;
import javax.transaction.xa.Xid;

public class FdbConnectionManager implements ConnectionManager {
    public Object allocateConnection(ManagedConnectionFactory factory, ConnectionRequestInfo info)
            throws ResourceException {
        if (managedConnectionFactory == null) {
            managedConnectionFactory = factory;
        } else {
            if (managedConnectionFactory != factory) {
                throw new ResourceException("FdbConnectionManager : should always use the same ManagedConnectionFactory.");
            }
        }
        ManagedConnection mc = managedConnectionFactory.createManagedConnection(null, info);
        Object res = mc.getConnection(null, info);
        mc.associateConnection(res);
        try {
            Xid xid = new FdbXid();
            ((FdbXAResourceWrapper)mc.getXAResource()).boundUnderlyingXaResource(xid);
        } catch (XAException e) {
            throw new ResourceException(e.getMessage());
        }
        return res;
    }

    ManagedConnectionFactory managedConnectionFactory;
}
