package org.objectweb.fdb.jca;

import org.objectweb.fdb.impl.trace.Trace;
import org.objectweb.fdb.impl.FdbTransactionImpl;
import org.objectweb.fdb.FdbSession;

import javax.resource.spi.LocalTransaction;
import javax.transaction.Synchronization;

public class FdbManagedTransactionImpl extends FdbTransactionImpl
        implements Synchronization, LocalTransaction {

    public FdbManagedTransactionImpl(FdbSession session, Trace trace) {
        super(session);
        this.trace = trace;
    }

    public void afterCompletion(int i) {
        out("afterCompletion... nothing done");
    }

    public void beforeCompletion() {
        out("beforeCompletion nothing done");
    }

    public void enlistAsSynchronization() {
        out("enlistAsSynchronization... nothing done");
    }

    public void begin() {
        out("begin()");
        super.begin();
    }

    public void commit() {
        out("commit()");
        super.commit();
    }

    public void rollback() {
        out("rollback()");
        super.rollback();
    }

    private void out(String msg) {
        trace.println(Trace.JCA, TRACE_ID + " " + msg);
    }

    private static final String TRACE_ID = "[FdbManagedTransactionImpl]";
    private Trace trace;
}
