package org.objectweb.fdb.jca;

import org.objectweb.fdb.impl.trace.Trace;
import org.objectweb.fdb.exception.FdbJcaException;

import javax.naming.Name;
import javax.naming.Context;
import javax.naming.Reference;
import javax.naming.spi.ObjectFactory;
import javax.resource.cci.ConnectionFactory;
import java.util.Hashtable;

public class FdbObjectFactory implements ObjectFactory {

    public Object getObjectInstance(Object refObj, Name name, Context nameCtx, Hashtable env)
            throws Exception {
        trace.println(Trace.JCA, TRACE_ID + " ClassLoader {0}" + FdbObjectFactory.class.getClassLoader());
        trace.println(Trace.JCA, TRACE_ID + " getObjectInstance \n{0}\nNaming pmfContext name : {1}",
                           refObj, name);
        trace.println(Trace.JCA, TRACE_ID + " registered factories {0}", factoryList);

        Reference ref = (Reference) refObj;
        String driverName = (String) ref.get(FDBID).getContent();
        Object connectionFactory = factoryList.get(driverName);
        if (connectionFactory == null) {
            throw new FdbJcaException("Fdb Driver resource adapter does not exist");
        }
        return connectionFactory;
    }

    public static Object getConnectionFactory(Reference ref) {
        String driverName = (String) ref.get(FDBID).getContent();
        return factoryList.get(driverName);
    }

    public static void addConnectionFactory(String factoryId, ConnectionFactory cf) {
        if (factoryList.contains(factoryId)) {
            throw new FdbJcaException("JCA resource adapter already exists");
        }
        factoryList.put(factoryId, cf);
        trace.println(Trace.JCA, "List " + factoryList);
    }



    public static void setTrace(Trace trace) {
        FdbObjectFactory.trace = trace;
    }




    private static final Hashtable factoryList = new Hashtable();
    private static Trace trace;

    private static final String TRACE_ID = "[FdbObjectFactory]";
    public static final String FDBID = "Naming.FDB";
}
