package org.objectweb.fdb.jca.data;

import org.objectweb.fdb.jca.FdbConnectionSpec;

import javax.resource.spi.ConnectionRequestInfo;
import javax.resource.cci.ConnectionSpec;

public class FdbConnectionRequestInfo implements ConnectionRequestInfo {
    private Object password = "";
    private Object userName = "";

    public FdbConnectionRequestInfo(ConnectionSpec spec) {
        if (spec != null) {
            try {
                FdbConnectionSpec jdoSpec = (FdbConnectionSpec) spec;
                userName = jdoSpec.getUserName();
                password = jdoSpec.getPassword();
            } catch (ClassCastException cce) {
            }
        }
    }

    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        }
        if (obj instanceof FdbConnectionRequestInfo) {
            FdbConnectionRequestInfo candidate = (FdbConnectionRequestInfo) obj;
            return (this.userName.equals(candidate.userName) && this.password.equals(candidate.password));
        }
        return false;
    }

    public int hashCode() {
        return super.hashCode();
    }

    public String toString() {
        return "FdbConnectionRequestInfo : username=" +
                String.valueOf(userName) + ", password=" +
                String.valueOf(password);
    }
}
