/*
 * $Id$
 * S.O.D.A.  -  Simple Object Database Access
 */
package org.odbms;


/**
 * for implementation of callback evaluations.
 * <br><br>
 * To constrain a {@link Query} node with your own callback
 * <code>Evaluation</code>, construct an object that implements the
 * <code>Evaluation</code> interface and register it by passing it
 * to {@link Query#constrain(Object) Query#constrain(Object)}.
 * <br><br>
 * Evaluations are called as the last step during query execution,
 * after all other constraints have been applied. Evaluations in higher
 * level {@link Query} nodes in the query graph are called first.
 */
public interface Evaluation extends java.io.Serializable {
	
	/**
	 * callback method during {@linkplain Query#execute query execution}.
	 * @param candidate reference to the candidate persistent object.
	 */
	public void evaluate(Candidate candidate);
	
}
