package fdbtests.tests;

import fdbtests.workbench.FdbTestCase;
import fdbtests.workbench.FdbTestSuite;
import fdbtests.workbench.Timer;
import fdbtests.data.Book;
import org.objectweb.fdb.FdbSession;
import org.objectweb.fdb.FdbTransaction;
import org.objectweb.fdb.FdbFactory;
import junit.framework.Test;

//import java.util.*;

//import com.db4o.*;

// you need the db4o classes to build this code

public class Db4oTestCase extends FdbTestCase {
//    FdbSession session = null;
//    FdbTransaction tx = null;
//
//    ObjectContainer db;
//
//    ArrayList oids = null;
//    ArrayList db4oObjects;
//
//    public Db4oTestCase() {
//    }
//
//    public Db4oTestCase(String name) {
//        super(name);
//    }
//
//    protected void tearDown() throws Exception {
//        super.tearDown();
//        if ((tx != null) && tx.isActive()) {
//            tx.rollback();
//        }
//    }
//
//    public static Test suite() {
//        FdbTestSuite suite = new FdbTestSuite();
//        Db4oTestCase tc = (Db4oTestCase) newTestCase(suite, new Db4oTestCase());
//
//        tc.newSession();
//        tc.define();
//
//        tc.cleanUpFdb(true);
//        tc.testFdb(200, 1000);
////        tc.populateFdb(500);
////        tc.stabilityTestFdb(50, 1000);
//
//        tc.cleanUpDb4o(true);
//        tc.testDb4o(200, 1000);
////        tc.populateDb4o(500);
////        tc.stabilityTestDb4o(50, 1000);
//
//        tc.finish();
//
//        return suite;
//    }
//
//    /******************************************************************************************/
//
//    public void newSession() {
//        System.gc();
//        session = FdbFactory.getNewSession(getFdbPropertiesFilename());
//        tx = session.currentTransaction();
//
//        db = Db4o.openFile("myDataFile.yap");
//    }
//
//    public void define() {
//        session.defineClass(Book.getMetaDescription());
//    }
//
//    public void cleanUpFdb(boolean withTimer) {
//        oids = new ArrayList();
//        if (withTimer) {
//            Timer.timerStart("clean fdb");
//        }
//        tx.begin();
//        Collection coll = session.getExtent(Book.class);
//        int nbr = coll.size();
//        Iterator extent = coll.iterator();
//        while (extent.hasNext()) {
//            Object oid = extent.next();
//            session.deleteObjectByOid(oid);
//        }
//        tx.commit();
//        if (withTimer) {
//            Timer.timerStop("clean fdb", false);
//        }
//    }
//
//    public void cleanUpDb4o(boolean withTimer) {
//        db4oObjects = new ArrayList();
//        if (withTimer) {
//            Timer.timerStart("clean db4o");
//        }
//        ObjectSet oSet = db.get(null);
//        int nbr = oSet.size();
//        while (oSet.hasNext()) {
//            Object o = oSet.next();
//            db.delete(o);
//        }
//        db.commit();
//        if (withTimer) {
//            Timer.timerStop("clean db4o", false);
//        }
//    }
//
//    public void populateFdb(int nbrBook) {
//        Timer.timerStart("populate fdb with "+nbrBook+" books");
//        tx.begin();
//        for (int i = 0; i < nbrBook; i++) {
//            Book book = Book.newBook();
//            oids.add(session.createObject(book.toArray(), Book.class));
//        }
//        tx.commit();
//        Timer.timerStop("populate fdb with "+nbrBook+" books", false);
//    }
//
//    public void populateDb4o(int nbrBook) {
//        Timer.timerStart("populate db4o with "+nbrBook+" books");
//        for (int i = 0; i < nbrBook; i++) {
//            Book book = Book.newBook();
//            db.set(book);
//            db4oObjects.add(book);
//        }
//        db.commit();
//        Timer.timerStop("populate db4o with "+nbrBook+" books", false);
//    }
//
//    public void stabilityTestFdb(int nbrCreate, int nbrIt) {
//        Random random = new Random();
//        String timerName = "Stability test fdb execution cycle";
//        Timer.createTimer(timerName);
//
//        for (int c = 0; c < nbrIt; c++) {
//            if ((c != 0) && ((c % 50) == 0)) {
//                Timer.summary(timerName);
//                Timer.clean(timerName);
//            }
//
//            Timer.timerStart(timerName);
//            tx.begin();
//            for (int i = 0; i < nbrCreate; i++) {
//                Object[] bookInArray = Book.newBook().toArray();
//                Object oid = session.createObject(bookInArray, Book.class);
//                oids.add(oid);
//            }
//            tx.commit();
//
//            tx.begin();
//            for (int i = 0; i < nbrCreate; i++) {
//                int index = random.nextInt(oids.size());
//                Object oid = oids.remove(index);
//                session.deleteObjectByOid(oid);
//            }
//            tx.commit();
//            Timer.timerStop(timerName, false);
//        }
//        Timer.clean(timerName);
//    }
//
//    public void stabilityTestDb4o(int nbrCreate, int nbrIt) {
//        Random random = new Random();
//        String timerName = "Stability test db4o execution cycle";
//        Timer.createTimer(timerName);
//
//        for (int c = 0; c < nbrIt; c++) {
//            if ((c != 0) && ((c % 50) == 0)) {
//                Timer.summary(timerName);
//                Timer.clean(timerName);
//            }
//
//            Timer.timerStart(timerName);
//            for (int i = 0; i < nbrCreate; i++) {
//                Book book = Book.newBook();
//                db.set(book);
//                db4oObjects.add(book);
//            }
//            db.commit();
//
//            for (int i = 0; i < nbrCreate; i++) {
//                int index = random.nextInt(db4oObjects.size());
//                Object o = db4oObjects.remove(index);
//                db.delete(o);
//            }
//            db.commit();
//            Timer.timerStop(timerName, false);
//        }
//        Timer.clean(timerName);
//    }
//
//    public void testFdb(int nbrCreate, int nbrIt) {
//        String createTimerName = "create test fdb execution cycle";
//        String deleteTimerName = "delete test fdb execution cycle";
//        Timer.createTimer(createTimerName);
//        Timer.createTimer(deleteTimerName);
//
//        oids.clear();
//
//        for (int c = 0; c < nbrIt; c++) {
//            if ((c != 0) && ((c % 50) == 0)) {
//                Timer.summary(createTimerName);
//                Timer.clean(createTimerName);
//                Timer.summary(deleteTimerName);
//                Timer.clean(deleteTimerName);
//            }
//
//            Timer.timerStart(createTimerName);
//            tx.begin();
//            for (int i = 0; i < nbrCreate; i++) {
//                Object[] bookInArray = Book.newBook().toArray();
//                Object oid = session.createObject(bookInArray, Book.class);
//                oids.add(oid);
//            }
//            tx.commit();
//            Timer.timerStop(createTimerName, false);
//
//            Timer.timerStart(deleteTimerName);
//            tx.begin();
//            for (int i = 0; i < nbrCreate; i++) {
//                session.deleteObjectByOid(oids.remove(0));
//            }
//            tx.commit();
//            Timer.timerStop(deleteTimerName, false);
//        }
//        Timer.clean(createTimerName);
//        Timer.clean(deleteTimerName);
//    }
//
//    public void testDb4o(int nbrCreate, int nbrIt) {
//        String createTimerName = "create test db4o execution cycle";
//        String deleteTimerName = "delete test db4o execution cycle";
//        Timer.createTimer(createTimerName);
//        Timer.createTimer(deleteTimerName);
//
//        db4oObjects.clear();
//
//        for (int c = 0; c < nbrIt; c++) {
//            if ((c != 0) && ((c % 50) == 0)) {
//                Timer.summary(createTimerName);
//                Timer.clean(createTimerName);
//                Timer.summary(deleteTimerName);
//                Timer.clean(deleteTimerName);
//            }
//
//            Timer.timerStart(createTimerName);
//            for (int i = 0; i < nbrCreate; i++) {
//                Book book = Book.newBook();
//                db.set(book);
//                db4oObjects.add(book);
//            }
//            db.commit();
//            Timer.timerStop(createTimerName, false);
//
//            Timer.timerStart(deleteTimerName);
//            for (int i = 0; i < nbrCreate; i++) {
//                db.delete(db4oObjects.remove(0));
//            }
//            db.commit();
//            Timer.timerStop(deleteTimerName, false);
//
////            System.out.println("db4oObjects.size() = "+db4oObjects.size());
////            System.out.println("number of objects in db4o store = "+db.get(null).size());
//        }
//        Timer.clean(createTimerName);
//        Timer.clean(deleteTimerName);
//    }
//
//    public void finish() {
//        db.close();
//        Timer.summary();
//    }
}
