package fdbtests.tests;

import fdbtests.workbench.FdbTestCase;
import fdbtests.workbench.FdbTestSuite;
import fdbtests.workbench.Timer;
import fdbtests.data.Book;
import org.objectweb.fdb.FdbSession;
import org.objectweb.fdb.FdbTransaction;
import org.objectweb.fdb.FdbFactory;
import junit.framework.Test;

import java.util.Iterator;
import java.util.ArrayList;
import java.util.Random;

public class InitStoreTestCase extends FdbTestCase {
    FdbSession session = null;
    FdbTransaction tx = null;

    public InitStoreTestCase() {
    }

    public InitStoreTestCase(String name) {
        super(name);
    }

    protected void tearDown() throws Exception {
        super.tearDown();

        if ((tx != null) && tx.isActive()) {
            tx.rollback();
        }
    }

    public static Test suite() {
        FdbTestSuite suite = new FdbTestSuite();
        InitStoreTestCase tc = (InitStoreTestCase) newTestCase(suite, new InitStoreTestCase());

        tc.define();

        return suite;
    }

    /******************************************************************************************/

    public void define() {
        session = FdbFactory.getNewSession(getFdbPropertiesFilename());
        tx = session.currentTransaction();
        session.defineClass(Book.getMetaDescription());
    }
}
