package fdbtests.workbench;

import junit.extensions.jfunc.JFuncTestCase;

import java.util.Properties;

public class FdbTestCase extends JFuncTestCase {
    private FdbTestEngine testEngine;

    public FdbTestCase() {
        super();
    }

    public FdbTestCase(String name) {
        super(name);
    }

    protected void setTestEngine(FdbTestEngine testEngine) {
        this.testEngine = testEngine;
    }

    protected void setUpOnce() throws Exception {
        System.err.println("=== INIT  ===");
        super.setUpOnce();
    }

    protected static Object newTestCase(FdbTestSuite suite,
                                        FdbTestCase testCase) {
        return suite.getTestProxy(testCase);
    }

    protected void tearDownOnce() throws Exception {
        super.tearDownOnce();
        System.err.println("=== CLOSE ===");
    }

    protected Properties getFdbProperties() {
        return testEngine.getDBProperties();
    }

    protected String getFdbPropertiesFilename() {
        return testEngine.getDBPropertiesFilename();
    }

    protected final Object[] oneObjectArray = new Object[1];
}
