package fdbtests.workbench;

import junit.extensions.jfunc.JFuncSuite;
import junit.extensions.jfunc.TestletWrapper;

import junit.framework.Test;
import junit.framework.TestResult;

import java.util.Enumeration;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;

import fdbtests.workbench.FdbTestCase;
import fdbtests.workbench.FdbTestEngine;


public class FdbTestSuite extends JFuncSuite {
    private FdbTestEngine testEngine;

    public FdbTestSuite() {
        oneTest(true);
    }

    //    protected void tearDownOnce(TestResult result) {
    //        Test test = null;
    //        for (Iterator i = getTests().iterator(); i.hasNext();) {
    //            test = (Test) i.next();
    //            if (test instanceof LidoTestCase) {
    //                try {
    //                    ((LidoTestCase) test).tearDown();
    //                } catch (Exception e) {
    //                    result.addError(test, e);
    //                }
    //            }
    //        }
    //        if (test instanceof LidoTestCase) {
    //            try {
    //                ((LidoTestCase) test).tearDownOnce();
    //            } catch (Exception e) {
    //                result.addError(test, e);
    //            }
    //        }
    //    }
    protected void setTestEngine(FdbTestEngine testEngine) {
        this.testEngine = testEngine;
    }

    protected void setUpOnce(TestResult result) {
        testEngine.suiteInit(this);

        boolean testCaseInit = true;

        for (Iterator i = getTests().iterator(); i.hasNext();) {
            Test test = (Test) i.next();

            if (test instanceof FdbTestCase) {
                try {
                    FdbTestCase ldTest = (FdbTestCase) test;

                    ldTest.setTestEngine(testEngine);

                    if (testCaseInit) {
                        ldTest.setUpOnce();
                        testCaseInit = false;
                    }
                } catch (Exception e) {
                    result.addError(test, e);
                }
            } else if (test instanceof FdbTestSuite) {
                FdbTestSuite ldSuite = (FdbTestSuite) test;

                try {
                    ldSuite.setTestEngine(testEngine);
                } catch (Exception e) {
                    result.addError(test, e);
                }
            }
        }
    }

    private Set getTests() {
        Set tests = new HashSet();

        for (Enumeration e = tests(); e.hasMoreElements();) {
            Test test = (Test) e.nextElement();

            if (test instanceof TestletWrapper) {
                test = ((TestletWrapper) test).getTestInstance();
            }

            tests.add(test);
        }

        return tests;
    }
}
